#include "Evalcorr.h"

void Evaluate(Kwlist& rkw , double& syserrcc , bool& poscorok , double Corr =0.5 , double Uncorr = 1.5 , double Radius_Threshold = 6.0 , double  Lik_Hood_Threshold = 5.0) {

		double r = sqrt(rkw["RAOFFSET"]*rkw["RAOFFSET"] + rkw["DEOFFSET"]*rkw["DEOFFSET"]);
		double lik_hood = rkw["LIK_HOOD"];

		if ( (r > Radius_Threshold) || (lik_hood < Lik_Hood_Threshold) ) {
			
			syserrcc = Uncorr;
			poscorok = 0;

		} else {

			syserrcc = Corr;
			poscorok = 1;
		}
		
}

void ReadKeywords(Table *table,Kwlist& read_kw) {

	const double Default_Value = 0.0;
	string kw;

	// keywords to be read
	// istrstream keywords_to_read("RAOFFSET RAOFFERR DEOFFSET DEOFFERR ROT_CORR ROT_ERR NMATCHES LIK_HOOD");
	istringstream keywords_to_read("RAOFFSET DEOFFSET LIK_HOOD");
	while(keywords_to_read >> kw) { 
	
		if (table->hasAttribute(kw)) {

			read_kw[kw] = table->attribute(kw)->asReal();
			errstr << "Read attribute " << kw << " = " << toString(read_kw[kw]) << Sas::message(Msg::App, Msg::Sparse);
		} else {
					
			read_kw[kw] = Default_Value;
			errstr << "Attribute " << kw << " not found"  << Sas::error("AttributeMissing");
		}
	}
}

void CopyCols(Table *table , bool makeamends) {

	// Columns to be copied
	// RA -> RA_CORR
	// DEC -> DEC_CORR
	// LII -> LII_CORR
	// BII -> BII_CORR

	int cols = 4;
	string from[4] = {"RA","DEC","LII","BII"};
	string to[4] = {"RA_CORR","DEC_CORR","LII_CORR","BII_CORR"};

	for(int i = 0; i< cols ; ++i) {

		if (table->hasColumn(to[i])) {

			if (makeamends) {	

				if(table->hasColumn(from[i])) {

					int pos = table->columnNumber(to[i]);
					table->deleteColumn(to[i]);
				
					table->add(table->column(from[i]) , to[i] , pos);

				} else {

					errstr << "Column " << from[i] << " not found in table"  << Sas::error("VitalColumnMissing");
				}

			}

			errstr << "Copied Column " << from[i] << " to " << to[i] << Sas::message(Msg::App, Msg::Sparse);

		} else {
				
			errstr << "Column " << to[i] << " not found in table"  << Sas::message(Msg::App, Msg::Sparse);
		
		}

	}
}

